# $2 - file in branch1 SHA1 (or empty)
# $3 - file in branch2 SHA1 (or empty)
# $4 - pathname in repository
-# $5 - orignal file mode (or empty)
+# $5 - original file mode (or empty)
# $6 - file in branch1 mode (or empty)
# $7 - file in branch2 mode (or empty)
#
"$1.." | "$1.$1" | "$1$1.")
if [ "$2" ]; then
echo "Removing $4"
+ else
+ # read-tree checked that index matches HEAD already,
+ # so we know we do not have this path tracked.
+ # there may be an unrelated working tree file here,
+ # which we should just leave unmolested.
+ exit 0
fi
if test -f "$4"; then
rm -f -- "$4" &&
- rmdir -p "$(expr "$4" : '\(.*\)/')" 2>/dev/null || :
+ rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
fi &&
exec git-update-index --remove -- "$4"
;;
#
# Added in one.
#
-".$2." | "..$3" )
+".$2.")
+ # the other side did not add and we added so there is nothing
+ # to be done.
+ ;;
+"..$3")
echo "Adding $4"
+ test -f "$4" || {
+ echo "ERROR: untracked $4 is overwritten by the merge."
+ exit 1
+ }
git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
exec git-checkout-index -u -f -- "$4"
;;
expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
;;
*)
- echo "Auto-merging $4."
+ echo "Auto-merging $4"
orig=`git-unpack-file $1`
;;
esac
- # Create the working tree file, with the correct permission bits.
- # we can not rely on the fact that our tree has the path, because
- # we allow the merge to be done in an unchecked-out working tree.
- rm -f "$4" &&
- git-cat-file blob "$2" >"$4" &&
- case "$6" in *7??) chmod +x "$4" ;; esac &&
- merge "$4" "$orig" "$src2"
+ # Be careful for funny filename such as "-L" in "$4", which
+ # would confuse "merge" greatly.
+ src1=`git-unpack-file $2`
+ git-merge-file "$src1" "$orig" "$src2"
ret=$?
- rm -f -- "$orig" "$src2"
+
+ # Create the working tree file, using "our tree" version from the
+ # index, and then store the result of the merge.
+ git-checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4"
+ rm -f -- "$orig" "$src1" "$src2"
if [ "$6" != "$7" ]; then
echo "ERROR: Permissions conflict: $5->$6,$7."
fi
if [ $ret -ne 0 ]; then
- echo "ERROR: Merge conflict in $4."
+ echo "ERROR: Merge conflict in $4"
exit 1
fi
exec git-update-index -- "$4"